"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDevServer = void 0;
const path_1 = __importDefault(require("path"));
const core_1 = require("@webpackon/core");
exports.useDevServer = (0, core_1.createConfigDecorator)((config, { mode, open = false, useLocalIp = false, proxy, hot = true, port }) => {
    var _a;
    if ((0, core_1.isProduction)(mode))
        return config;
    const plugins = [];
    const modifyConfig = (0, core_1.addPlugins)(plugins);
    const outputPath = ((_a = config.output) === null || _a === void 0 ? void 0 : _a.path) || path_1.default.resolve(process.cwd(), 'dist');
    return modifyConfig({
        ...config,
        devtool: 'eval-source-map',
        devServer: {
            port,
            static: outputPath,
            host: useLocalIp ? 'local-ip' : undefined,
            hot,
            historyApiFallback: true,
            client: {
                overlay: true,
            },
            devMiddleware: {
                index: true,
            },
            open,
            proxy,
        },
        cache: {
            type: 'filesystem',
            cacheLocation: path_1.default.join(outputPath, '.cache-dev'),
            compression: 'brotli',
        },
    });
});
